<div [ngSwitch]="type">
  <button *ngSwitchCase="'raised'" mat-raised-button
    [type]="behavior"
    [color]="color"
    [disabled]="disabled"
    (click)="onClick($event)">
    {{ label }}
  </button>
  <button *ngSwitchCase="'stroked'" mat-stroked-button
    [type]="behavior"
    [color]="color"
    [disabled]="disabled"
    (click)="onClick($event)">
    {{ label }}
  </button>
  <button *ngSwitchCase="'flat'" mat-flat-button
    [type]="behavior"
    [color]="color"
    [disabled]="disabled"
    (click)="onClick($event)">
    {{ label }}
  </button>
  <button *ngSwitchCase="'icon'" mat-icon-button
    [type]="behavior"
    [color]="color"
    [disabled]="disabled"
    (click)="onClick($event)">
    <mat-icon [attr.arial-label]="label">{{ icon }}</mat-icon>
  </button>
  <button *ngSwitchCase="'fab'" mat-fab
    [type]="behavior"
    [color]="color"
    [disabled]="disabled"
    (click)="onClick($event)">
    <mat-icon *ngIf="icon; else showLabel" [attr.arial-label]="label">{{ icon }}</mat-icon>
    <ng-template #showLabel>{{ label }}</ng-template>
  </button>
  <button *ngSwitchCase="'mini-fab'" mat-mini-fab
    [type]="behavior"
    [color]="color"
    [disabled]="disabled"
    (click)="onClick($event)">
    <mat-icon *ngIf="icon; else showLabel" [attr.arial-label]="label">{{ icon }}</mat-icon>
    <ng-template #showLabel>{{ label }}</ng-template>
  </button>
  <button *ngSwitchDefault mat-button
    [type]="behavior"
    [color]="color"
    [disabled]="disabled"
    (click)="onClick($event)">
    {{ label }}
  </button>
</div>